import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Koch extends PApplet {


int __x=0,__y=0; // var globali

public void setup() 
{
  background(255);
  size(600, 600);
  stroke(0);
  smooth();
  noLoop();
}

int order=0;


public void draw() 
  {
     background(255);
     stroke(0);
    
     snowFlake(order,300,250,400);
     
  }
  

  
public void snowFlake(int order, int xc, int yc, float L)
  {
    int x=round(xc-L/2),y=round(yc+sqrt(3)*L/4.0f);
    setPoint(x,y);
    fractLine(order,L,0);
    fractLine(order,L,-120);
    fractLine(order,L,-240);
  }  

public void fractLine(int order, float L, float theta)
  {
    if (order==0)
      polarVec(L,theta);
    else
      {
        fractLine(order-1,L/3,theta);
        fractLine(order-1,L/3,theta+60);
        fractLine(order-1,L/3,theta-60);
        fractLine(order-1,L/3,theta);
      }
  }    
public void polarVec(float r, float theta)
  {
    int x__, y__;
    theta=radians(theta);
    x__=round(__x+r*cos(theta));
    y__=round(__y+r*sin(theta));
    line(__x,__y,x__,y__);
    __x=x__;
    __y=y__;
  }  
    
public void setPoint(int x,int y)
  {
    __x=x; __y=y;
  }  

  public void mousePressed() 
  {
    redraw();
    order++;
    if (order==5)
      order=0;
  }
 
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#ECE9D8", "Koch" });
  }
}
